---
title: WebGL2RenderingContext.drawRangeElements()
slug: Web/API/WebGL2RenderingContext/drawRangeElements
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.drawRangeElements()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> renders primitives from array data in a given range.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.drawRangeElements(<var>mode</var>, <var>start</var>, <var>end</var>, <var>count</var>, <var>type</var>, <var>offset</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>mode</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the type primitive to render. Possible values are:
 <ul>
  <li><code>gl.POINTS</code>: Draws a single dot.</li>
  <li><code>gl.LINE_STRIP</code>: Draws a straight line to the next vertex.</li>
  <li><code>gl.LINE_LOOP</code>: Draws a straight line to the next vertex, and connects the last vertex back to the first.</li>
  <li><code>gl.LINES</code>: Draws a line between a pair of vertices.</li>
  <li><code><a href="https://en.wikipedia.org/wiki/Triangle_strip">gl.TRIANGLE_STRIP</a></code></li>
  <li><code><a href="https://en.wikipedia.org/wiki/Triangle_fan">gl.TRIANGLE_FAN</a></code></li>
  <li><code>gl.TRIANGLES</code>: Draws a triangle for a group of three vertices.</li>
 </ul>
 </dd>
 <dt><code>start</code></dt>
 <dd>A {{domxref("GLuint")}} specifying the minimum array index contained in <code>offset</code>.</dd>
 <dt><code>end</code></dt>
 <dd>A {{domxref("GLuint")}} specifying the maximum array index contained in <code>offset</code>.</dd>
 <dt>count</dt>
 <dd>A {{domxref("GLsizei")}} specifying the number of elements to be rendered.</dd>
 <dt>type</dt>
 <dd>A {{domxref("GLenum")}} specifying the type of the values in the element array buffer. Possible values are:
 <ul>
  <li><code>gl.UNSIGNED_BYTE</code></li>
  <li><code>gl.UNSIGNED_SHORT</code></li>
  <li><code>gl.UNSIGNED_INT</code></li>
 </ul>
 </dd>
 <dt>offset</dt>
 <dd>A {{domxref("GLintptr")}} specifying an offset in the element array buffer. Must be a valid multiple of the size of the given <code>type</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>If <code>mode</code> is not one of the accepted values, a <code>gl.INVALID_ENUM</code> error is thrown.</li>
 <li>If <code>offset</code> is a valid multiple of the size of the given type, a <code>gl.INVALID_OPERATION</code> error is thrown.</li>
 <li>If <code>count</code> is negative, a <code>gl.INVALID_VALUE</code> error is thrown.</li>
</ul>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.drawRangeElements(gl.POINTS, 0, 7, 8, gl.UNSIGNED_BYTE, 0);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.9", "drawRangeElements")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glDrawRangeElements.xhtml", "glDrawRangeElements")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.drawRangeElements")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.drawElements()")}}</li>
</ul>
